#include <stdio.h>
#include <string.h>
#include <ihm.h>
#include <kmus.h>

#include <telec_pix.h>

static XtIntervalId tempo_slider;

static Widget form0, form1;
static Widget xmSeparator0_5, xmSeparator2_17, xmSeparator3_21, xmSeparator1_7;
static Widget xmRowColumn0, xmRowColumn1, xmRowColumn2;

Widget pluss_v, pluss_r, pluss_t, moinss_v, moinss_r, moinss_t;
Widget volume, rythme, trans;
Widget pb_pup, pb_pdown, pb_home, pb_speed;
Widget pb_quit, pb_next, pb_prev, pb_play;
Widget lab_time, scroll_time, tb_vrt;
Widget pb_front_mus, pb_front_lyr, pb_front_dir;
Widget form2, lab_buttons;


int  f_kmus_CreateGeneralControl ()
{
 Pixmap play_pix, pause_pix, pup_pix,pdown_pix, home_pix;
 Pixmap stop_pix, avr_pix, pluss_pix, moinss_pix;
 Pixmap volume_pix,rythme_pix,trans_pix;
 Pixmap song_pix, lyr_pix, mus_pix, down_pix, up_pix;
 Pixmap exit_pix;

 play_pix = f_kar_CreatePixmap ("play.xpm", play_xpm);
 pause_pix = f_kar_CreatePixmap ("pause.xpm", pause_xpm);
 pup_pix = f_kar_CreatePixmap ("pup.xpm", pup_xpm);
 pdown_pix = f_kar_CreatePixmap ("pdown.xpm", pdown_xpm);
 home_pix = f_kar_CreatePixmap ("home.xpm", home_xpm);
 stop_pix = f_kar_CreatePixmap ("stop.xpm", stop_xpm);
 avr_pix = f_kar_CreatePixmap ("avr.xpm", avr_xpm);
 pluss_pix = f_kar_CreatePixmap ("pluss.xpm", pluss_xpm);
 moinss_pix = f_kar_CreatePixmap ("moinss.xpm", moinss_xpm);
 volume_pix = f_kar_CreatePixmap ("volume.xpm", volume_xpm);
 rythme_pix = f_kar_CreatePixmap ("rythme.xpm", rythme_xpm);
 trans_pix = f_kar_CreatePixmap ("trans.xpm", trans_xpm);
 song_pix = f_kar_CreatePixmap ("song.xpm", song_xpm);
 mus_pix = f_kar_CreatePixmap ("mus.xpm", mus_xpm);
 lyr_pix = f_kar_CreatePixmap ("lyr.xpm", lyr_xpm);
 down_pix = f_kar_CreatePixmap ("down.xpm", down_xpm);
 up_pix = f_kar_CreatePixmap ("up.xpm", up_xpm);
 exit_pix = f_kar_CreatePixmap ("exit.xpm", exit_xpm);


	form0 = XtVaCreateWidget("form0", xmFormWidgetClass, top_level,
		NULL, NULL);


	form1 = XtVaCreateManagedWidget("form1", xmFormWidgetClass, form0,
		XmNrightAttachment, XmATTACH_FORM,
		XmNleftAttachment, XmATTACH_FORM,
		NULL);


	lab_time = XtVaCreateManagedWidget("lab_time", xmLabelWidgetClass, form1,
		XmNrightAttachment, XmATTACH_FORM,
		XmNleftAttachment, XmATTACH_FORM,
		NULL);


	scroll_time = XtVaCreateManagedWidget("scroll_time", xmGaugeWidgetClass, form1,
		XmNtopAttachment, XmATTACH_WIDGET,
		XmNheight, 10,
		XmNtopWidget, lab_time,
		XmNorientation, XmHORIZONTAL,
		XmNrightAttachment, XmATTACH_FORM,
		XmNleftAttachment, XmATTACH_FORM,
		NULL);


	xmSeparator0_5 = XtVaCreateManagedWidget("xmSeparator0", xmSeparatorWidgetClass, form1,
		XmNrightAttachment, XmATTACH_FORM,
		XmNtopAttachment, XmATTACH_WIDGET,
		XmNtopOffset, 3,
		XmNtopWidget, scroll_time,
		XmNleftAttachment, XmATTACH_FORM,
		NULL);



	lab_buttons = XtVaCreateManagedWidget("lab_buttons", xmLabelWidgetClass, form1,
		XmNrightAttachment, XmATTACH_FORM,
		XmNleftAttachment, XmATTACH_FORM,
		XmNleftOffset, 0,
		XmNtopAttachment, XmATTACH_WIDGET,
		XmNtopOffset, 0,
		XmNtopWidget, xmSeparator0_5,
		NULL);


	pb_front_mus = XtVaCreateManagedWidget("pb_front_mus", xmPushButtonWidgetClass, form1,
		XmNtopAttachment, XmATTACH_WIDGET,
		XmNrightAttachment, XmATTACH_POSITION,
		XmNrightPosition, 33,
		XmNtopWidget, lab_buttons,
		XmNleftAttachment, XmATTACH_FORM,
		XmNtopOffset, 5,
		XmNlabelType, XmPIXMAP,
		XmNlabelPixmap, mus_pix,
		XmNlabelInsensitivePixmap, mus_pix,
		NULL);

	XtAddCallback (pb_front_mus, XmNactivateCallback, f_act_kmusic, NULL);

	pb_front_lyr = XtVaCreateManagedWidget("pb_front_lyr", xmPushButtonWidgetClass, form1,
		XmNtopAttachment, XmATTACH_OPPOSITE_WIDGET,
		XmNrightAttachment, XmATTACH_POSITION,
		XmNrightPosition, 66,
		XmNtopWidget, pb_front_mus,
		XmNleftAttachment, XmATTACH_WIDGET,
		XmNleftWidget, pb_front_mus,
		XmNlabelType, XmPIXMAP,
		XmNlabelPixmap, lyr_pix,
		XmNlabelInsensitivePixmap, lyr_pix,
		NULL);

	XtAddCallback (pb_front_lyr, XmNactivateCallback, f_act_klyric, NULL);


	pb_front_dir = XtVaCreateManagedWidget("pb_front_dir", xmPushButtonWidgetClass, form1,
		XmNtopAttachment, XmATTACH_OPPOSITE_WIDGET,
		XmNleftOffset, 0,
		XmNrightAttachment, XmATTACH_FORM,
		XmNtopWidget, pb_front_lyr,
		XmNleftAttachment, XmATTACH_WIDGET,
		XmNleftWidget, pb_front_lyr,
		XmNlabelType, XmPIXMAP,
		XmNlabelPixmap, song_pix,
		XmNlabelInsensitivePixmap, song_pix,
		NULL);

	XtAddCallback (pb_front_dir, XmNactivateCallback, f_act_kdir, NULL);


	xmSeparator1_7 = XtVaCreateManagedWidget("xmSeparator1", xmSeparatorWidgetClass, form1,
		XmNrightAttachment, XmATTACH_FORM,
		XmNleftAttachment, XmATTACH_FORM,
		XmNtopAttachment, XmATTACH_WIDGET,
		XmNtopOffset, 1,
		XmNtopWidget, pb_front_mus,
		NULL);


	pb_home = XtVaCreateManagedWidget("pb_home", xmPushButtonWidgetClass, form1,
		XmNrightAttachment, XmATTACH_POSITION,
		XmNrightPosition, 47,
		XmNleftAttachment, XmATTACH_POSITION,
		XmNtopAttachment, XmATTACH_WIDGET,
		XmNtopOffset, 3,
		XmNtopWidget, xmSeparator1_7,
		XmNleftPosition, 3,
		XmNlabelType, XmPIXMAP,
		XmNlabelPixmap, home_pix,
		XmNlabelInsensitivePixmap, home_pix,
		NULL);

	XtAddCallback (pb_home, XmNactivateCallback, f_home_song, NULL);

	/* XFM create remote_control.xmForm0_2.xmForm0.pb_play */
	pb_play = XtVaCreateManagedWidget("pb_play", xmToggleButtonWidgetClass, form1,
		XmNleftAttachment, XmATTACH_POSITION,
		XmNleftPosition, 53,
		XmNrightAttachment, XmATTACH_POSITION,
		XmNrightPosition, 97,
		XmNtopAttachment, XmATTACH_WIDGET,
		XmNtopOffset, 3,
		XmNtopWidget, xmSeparator1_7,
		XmNlabelType, XmPIXMAP,
		XmNlabelInsensitivePixmap, play_pix,
		XmNlabelPixmap, play_pix,
		XmNselectPixmap, pause_pix,
		XmNindicatorOn, False,
		XmNshadowThickness, 2,
		XmNset, True,
		NULL);

	XtAddCallback (pb_play, XmNvalueChangedCallback, 
		(XtCallbackProc)f_play_song, NULL);

	

	pb_pdown = XtVaCreateManagedWidget("pb_pdown", xmPushButtonWidgetClass, form1,
		XmNleftAttachment, XmATTACH_POSITION,
		XmNleftPosition, 3,
		XmNrightAttachment, XmATTACH_POSITION,
		XmNrightPosition, 47,
		XmNtopAttachment, XmATTACH_WIDGET,
		XmNtopOffset, 3,
		XmNtopWidget, pb_home,
		XmNlabelType, XmPIXMAP,
		XmNlabelPixmap, pdown_pix,
		XmNlabelInsensitivePixmap, pdown_pix,
		NULL);


	pb_pup = XtVaCreateManagedWidget("pb_pup", xmPushButtonWidgetClass, form1,
		XmNleftAttachment, XmATTACH_POSITION,
		XmNleftOffset, 0,
		XmNleftPosition, 53,
		XmNrightAttachment, XmATTACH_POSITION,
		XmNrightPosition, 97,
		XmNtopAttachment, XmATTACH_WIDGET,
		XmNtopOffset, 3,
		XmNtopWidget, pb_play,
		XmNlabelType, XmPIXMAP,
		XmNlabelInsensitivePixmap, pup_pix,
		XmNlabelPixmap, pup_pix,
		NULL);

	pb_speed = XtVaCreateManagedWidget("pb_speed", xmPushButtonWidgetClass, form1,
		XmNtopAttachment, XmATTACH_WIDGET,
		XmNtopOffset, 2,
		XmNtopWidget, pb_pdown,
		XmNleftAttachment, XmATTACH_POSITION,
		XmNleftPosition, 3,
		XmNrightAttachment, XmATTACH_POSITION,
		XmNrightPosition, 97,
		XmNlabelType, XmPIXMAP,
		XmNlabelInsensitivePixmap, avr_pix,
		XmNlabelPixmap, avr_pix,
		NULL);

	XtAddCallback (pb_speed, XmNarmCallback, 
		(XtCallbackProc)f_speed_arm, NULL);
	XtAddCallback (pb_speed, XmNdisarmCallback, 
		(XtCallbackProc)f_speed_disarm, NULL);

	/* XFM create remote_control.xmForm0_2.xmForm0.pb_stop */
/*	pb_stop = XtVaCreateManagedWidget("pb_stop", xmPushButtonWidgetClass, form1,
		XmNtopAttachment, XmATTACH_WIDGET,
		XmNtopOffset, 2,
		XmNtopWidget, pb_speed,
		XmNleftAttachment, XmATTACH_POSITION,
		XmNleftPosition, 3,
		XmNrightAttachment, XmATTACH_POSITION,
		XmNrightPosition, 97,
		XmNlabelType, XmPIXMAP,
		XmNlabelPixmap, stop_pix,
		XmNlabelInsensitivePixmap, stop_pix,
		NULL);

	XtAddCallback (pb_stop, XmNactivateCallback, f_stop_song, NULL);
*/



	/* XFM create remote_control.xmForm0_2.xmForm0.pb_quit */
	pb_quit = XtVaCreateManagedWidget("pb_quit", xmPushButtonWidgetClass, form1,
		XmNtopAttachment, XmATTACH_WIDGET,
		XmNtopWidget, pb_speed,
		XmNtopOffset, 2,
		XmNrightAttachment, XmATTACH_POSITION,
		XmNrightPosition, 97,
		XmNleftAttachment, XmATTACH_POSITION,
		XmNleftPosition, 3,
		XmNlabelType, XmPIXMAP,
		XmNlabelPixmap, exit_pix,
		XmNlabelInsensitivePixmap, exit_pix,
		NULL);

	XtAddCallback (pb_quit, XmNactivateCallback, 
		(XtCallbackProc)f_quit, NULL);


	xmSeparator2_17 = XtVaCreateManagedWidget("xmSeparator2", xmSeparatorWidgetClass, form1,
		XmNtopAttachment, XmATTACH_WIDGET,
		XmNtopWidget, pb_quit,
		XmNrightAttachment, XmATTACH_FORM,
		XmNleftAttachment, XmATTACH_FORM,
		XmNseparatorType, XmSHADOW_ETCHED_IN_DASH,
		NULL);


	pb_prev = XtVaCreateManagedWidget("pb_prev", xmPushButtonWidgetClass, form1,
		XmNtopAttachment, XmATTACH_WIDGET,
		XmNtopWidget, xmSeparator2_17,
		XmNtopOffset, 2,
		XmNleftAttachment, XmATTACH_POSITION,
		XmNleftPosition, 3,
		XmNrightAttachment, XmATTACH_POSITION,
		XmNrightPosition, 47,
		XmNlabelType, XmPIXMAP,
		XmNlabelPixmap, down_pix,
		XmNlabelInsensitivePixmap, down_pix,
		NULL);


	pb_next = XtVaCreateManagedWidget("pb_next", xmPushButtonWidgetClass, form1,
		XmNtopAttachment, XmATTACH_OPPOSITE_WIDGET,
		XmNtopWidget, pb_prev,
		XmNleftAttachment, XmATTACH_POSITION,
		XmNleftPosition, 53,
		XmNrightAttachment, XmATTACH_POSITION,
		XmNrightPosition, 97,
		XmNlabelType, XmPIXMAP,
		XmNlabelPixmap, up_pix,
		XmNlabelInsensitivePixmap, up_pix,
		0, 0);


	xmSeparator3_21 = XtVaCreateManagedWidget("xmSeparator3", xmSeparatorWidgetClass, form1,
		XmNtopAttachment, XmATTACH_WIDGET,
		XmNtopWidget, pb_next,
		XmNleftAttachment, XmATTACH_FORM,
		XmNrightAttachment, XmATTACH_FORM,
		XmNtopOffset, 2,
		XmNseparatorType, XmSHADOW_ETCHED_IN_DASH,
		NULL);


	tb_vrt = XtVaCreateManagedWidget("tb_vrt", xmToggleButtonWidgetClass, form1,
		XmNbottomAttachment, XmATTACH_FORM,
		XmNtopAttachment, XmATTACH_WIDGET,
		XmNtopWidget, xmSeparator3_21,
		XmNtopOffset, 2,
		XmNrightAttachment, XmATTACH_FORM,
		XmNleftAttachment, XmATTACH_FORM,
		XmNalignment, XmALIGNMENT_CENTER,
		XmNindicatorType, XmONE_OF_MANY,
		XmNindicatorSize, 10,
		XmNmarginLeft, 0,
		XmNmarginHeight, 0,
		XmNmarginBottom, 0,
		XmNhighlightOnEnter, False,
		XmNhighlightThickness, 4,
		XmNmarginTop, 0,
		XmNmarginWidth, 0,
		NULL);

	XtAddCallback (tb_vrt, XmNvalueChangedCallback, f_kmus_vrt, NULL);


	/* XFM create remote_control.xmForm0_2.xmForm1 */
	form2 = XtVaCreateWidget("form2", xmFormWidgetClass, form0,
		XmNrightAttachment, XmATTACH_FORM,
		XmNtopAttachment, XmATTACH_WIDGET,
		XmNtopWidget, form1,
		XmNbottomAttachment, XmATTACH_FORM,
		XmNleftAttachment, XmATTACH_FORM,
		NULL);


	xmRowColumn0 = XtVaCreateManagedWidget("xmRowColumn0", xmRowColumnWidgetClass, form2,
		XmNorientation, XmHORIZONTAL,
		NULL);


	moinss_v = XtVaCreateManagedWidget("moinss_v", xmPushButtonWidgetClass, xmRowColumn0,
		XmNlabelType, XmPIXMAP,
		XmNlabelPixmap, moinss_pix,
		XmNlabelInsensitivePixmap, moinss_pix,
		NULL);

	volume = XtVaCreateManagedWidget("volume", xmPushButtonWidgetClass, xmRowColumn0,
		XmNlabelType, XmPIXMAP,
		XmNlabelPixmap, volume_pix,
		XmNlabelInsensitivePixmap, volume_pix,
		NULL);

	pluss_v = XtVaCreateManagedWidget("pluss_v", xmPushButtonWidgetClass, xmRowColumn0,
		XmNlabelType, XmPIXMAP,
		XmNlabelPixmap, pluss_pix,
		XmNlabelInsensitivePixmap, pluss_pix,
		NULL);


	xmRowColumn1 = XtVaCreateManagedWidget("xmRowColumn1", xmRowColumnWidgetClass, form2,
		XmNorientation, XmHORIZONTAL,
		XmNtopAttachment, XmATTACH_WIDGET,
		XmNtopWidget, xmRowColumn0,
		NULL);

	moinss_r = XtVaCreateManagedWidget("moinss_r", xmPushButtonWidgetClass, xmRowColumn1,
		XmNlabelType, XmPIXMAP,
		XmNlabelInsensitivePixmap, moinss_pix,
		XmNlabelPixmap, moinss_pix,
		NULL);

	rythme = XtVaCreateManagedWidget("rythme", xmPushButtonWidgetClass, xmRowColumn1,
		XmNlabelType, XmPIXMAP,
		XmNlabelPixmap, rythme_pix,
		XmNlabelInsensitivePixmap, rythme_pix,
		NULL);

	pluss_r = XtVaCreateManagedWidget("pluss_r", xmPushButtonWidgetClass, xmRowColumn1,
		XmNlabelType, XmPIXMAP,
		XmNlabelPixmap, pluss_pix,
		XmNlabelInsensitivePixmap, pluss_pix,
		NULL);


	xmRowColumn2 = XtVaCreateManagedWidget("xmRowColumn0_3", xmRowColumnWidgetClass, form2,
		XmNorientation, XmHORIZONTAL,
		XmNtopAttachment, XmATTACH_WIDGET,
		XmNtopWidget, xmRowColumn1,
		NULL);

	moinss_t = XtVaCreateManagedWidget("moinss_t", xmPushButtonWidgetClass, xmRowColumn2,
		XmNlabelType, XmPIXMAP,
		XmNlabelInsensitivePixmap, moinss_pix,
		XmNlabelPixmap, moinss_pix,
		NULL);

	trans = XtVaCreateManagedWidget("trans", xmPushButtonWidgetClass, xmRowColumn2,
		XmNlabelType, XmPIXMAP,
		XmNlabelPixmap, trans_pix,
		XmNlabelInsensitivePixmap, trans_pix,
		NULL);


	pluss_t= XtVaCreateManagedWidget("pluss_t", xmPushButtonWidgetClass, xmRowColumn2,
		XmNlabelType, XmPIXMAP,
		XmNlabelPixmap, pluss_pix,
		XmNlabelInsensitivePixmap, pluss_pix,
		NULL);


 EventLeaveEnterWidgets();

 ArmDisarmCtrls();

 XtManageChild (form0);



 tempo_slider = XtAppAddTimeOut(p_kar_ctx,SLIDER_INTERVAL,f_kmus_time_slider,NULL);

}

